forums/urls.py
#
# Copyright 2016, Martin Owens <doctormo@gmail.com>
#
# This file is part of the software inkscape-web, consisting of custom
# code for the Inkscape project's django-based website.
#
# inkscape-web is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# inkscape-web is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with inkscape-web.  If not, see <http://www.gnu.org/licenses/>.
#
"""
Forum views accessable from the website.
"""

from django.conf.urls import include, url
from inkscape.url_utils import url_tree
from person import user_urls

from .views import (
    ModerationList, ForumList,
    TopicList, TopicDetail, TopicCreate, TopicMove, TopicEdit, TopicDelete,
    TopicMerge, TopicSplit, UserTopicList, UnreadTopicList,
    CommentList, CommentCreate, CommentEdit, CommentEmote, Subscriptions,
    CommentModList, CommentModPublic, CommentModRemove, CommentRaw,
    UserFlagList, UserModList, UserBanList, WordBanList,
    UserFlagToggle, UserModToggle, UserBanToggle, WordBanCreate, WordBanDelete,
    ForumStats,
)
from .rss import ForumTopicFeed

from .search_views import CommentSearch, TopicSearch, TopicSubjectSearch

app_name = 'forums'

user_urls.urlpatterns += [
    url(r'^comments/$', CommentList.as_view(), name="comment_list"),
    url(r'^topics/$', UserTopicList.as_view(), name="topic_list"),
    url(r'^topics/rss/$', ForumTopicFeed(), name='topic_feed'),
]

urlpatterns = [ # pylint: disable=invalid-name
    url(r'^$', ForumList.as_view(), name="list"),
    url(r'^log/$', ModerationList.as_view(), name="log"),
    url(r'^stats/$', ForumStats.as_view(), name="stats"),
    url_tree(
        r'^users/',
        url(r'^banned/$', UserBanList.as_view(), name='ban_list'),
        url(r'^words/$', WordBanList.as_view(), name='word_list'),
        url(r'^mods/$', UserModList.as_view(), name='mod_list'),
        url(r'^flags/$', UserFlagList.as_view(), name='flag_list'),
        url(r'^banned/flag/$', UserBanToggle.as_view(), name='ban_user'),
        url(r'^mods/flag/$', UserModToggle.as_view(), name='mod_user'),
        url(r'^flags/flag/$', UserFlagToggle.as_view(), name='flag_user'),
        url(r'^words/create/$', WordBanCreate.as_view(), name='create_words'),
        url(r'^words/delete/(?P<pk>\d+)/$', WordBanDelete.as_view(), name='delete_words'),
    ),
    url(r'^unread/$', UnreadTopicList.as_view(), name="unread"),
    url(r'^check/$', CommentModList.as_view(), name="check"),
    url(r'^search/$', TopicSubjectSearch(), name='search'),
    url(r'^search/topics/$', TopicSearch(), name='search.topics'),
    url(r'^search/posts/$', CommentSearch(), name='search.posts'),
    url(r'^topics/$', TopicList.as_view(), name="topic_list"),
    url(r'^subscriptions/$', Subscriptions.as_view(), name="topic_subs"),
    url(r'^~(?P<username>[^\/]+)/rss/$', ForumTopicFeed(), name='topic_feed'),
    url_tree(
        r'^c(?P<pk>\d+)/',
        url(r'^$', CommentRaw.as_view(), name='comment_raw'),
        url(r'^emote/$', CommentEmote.as_view(), name='emote'),
        url(r'^edit/$', CommentEdit.as_view(), name='comment_edit'),
        url(r'^rem/$', CommentModRemove.as_view(), name='comment_remove'),
        url(r'^pub/$', CommentModPublic.as_view(), name='comment_public'),
    ),
    url_tree(
        r'^(?P<slug>[\w-]+)/',
        url(r'^$', TopicList.as_view(), name='topic_list'),
        url(r'^rss/$', ForumTopicFeed(), name='topic_feed'),
        url(r'^new/$', TopicCreate.as_view(), name='create'),
        url(r'^move/$', TopicMove.as_view(), name='topic_move'),
        url(r'^edit/$', TopicEdit.as_view(), name='topic_edit'),
        url(r'^del/$', TopicDelete.as_view(), name='topic_delete'),
        url(r'^merge/$', TopicMerge.as_view(), name='topic_merge'),
        url(r'^split/$', TopicSplit.as_view(), name='topic_split'),
    ),
    url_tree(
        r'^(?P<forum>[\w-]+)/(?P<slug>[\w-]+)/',
        url(r'^$', TopicDetail.as_view(), name='topic'),
        url(r'^comment/$', CommentCreate.as_view(), name='comment_create'),
    ),
]

forums/templates/forums/bannedwords_confirm_delete.html
{% extends 'modal.html' %}
{% load i18n %}

{% block "form-buttons" %}
  <button id="moreInfo" class="btn btn-danger" type="submit" name="delete" value="1">{% trans "Delete Banned Words" %}</button>
{% endblock %}

forums/templates/forums/base_search.html
{% extends "forums/base.html" %}
{% load i18n static inkscape highlight %}
{% block title %}{% trans "Search" %}{% endblock %}
{% block "wrapper" %}
<div class="container-flex forums-app forums-search-context">
{% endblock "wrapper" %}
{% block "forumheader" %}
  <div class="forum-sub-header">
    {% if forum %}
      <a href="{{ forum.get_absolute_url }}">{% if forum.icon %}<img src="{{ forum.icon.url }}" title="{{ forum }}"> {% endif %}{{ forum }}</a>
    {% else %}
      <a href="{% url "forums:list" %}"><img src="{% static "forums/images/logo.svg" %}"> {% trans "Whole Forum" %}</a>
    {% endif %}
    <span class="glyphicon glyphicon-chevron-right"></span> <span class="forum-thread-title">{% block "searchtitle" %}{% trans "Search" %}{% endblock %}</span>
  </div>
{% endblock %}

{% block "aside" %}
 <aside class="sm-side forum-sidebar">
  <ul class="nav nav-pills nav-stacked labels-info">
    <li>
      <h4>{% trans "Searches" %}</h4>
    </li>
    <li class="forum-item new{% if search_name == "TopicSubjectSearch" %} active{% endif %}">
      <a href="{% url "forums:search" %}?q={{ query }}"><span class="glyphicon glyphicon-comment"></span> {% trans "Topic Subject" %}</a>
    </li>
    <li class="forum-item new{% if search_name == "CommentSearch" %} active{% endif %}">
      <a href="{% url "forums:search.posts" %}?q={{ query }}"><span class="glyphicon glyphicon-tag"></span> {% trans "Comment Text" %}</a>
    </li>
    <li class="forum-item new{% if search_name == "TopicSearch" %} active{% endif %}">
      <a href="{% url "forums:search.topics" %}?q={{ query }}"><span class="glyphicon glyphicon-tags"></span> {% trans "Topic Threads" %}</a>
    </li>
  </ul>
 </aside>
{% endblock %}

{% block "tools" %}
  {% with page as page_obj and 1 as is_paginated %}{{ block.super }}{% endwith %}
{% endblock %}

{% block "content" %}
  <table class="table table-forum table-hover" data-pk="forum-{{ forum.pk }}">
    <tbody>
    {% for comment in page.object_list %}
      <tr class="{% cycle 'odd' 'even' %}" data-changed="{{ comment.submit_date.isoformat }}" data-pk="topic-{{ topic.pk }}">
        <td class="subscribed forum-small-cells avatar"><img src="{{ comment.object.user.photo_url }}"/></td>
        <td class="view-message"><a href="{{ comment.get_absolute_url }}">{% highlight comment.text with query max_length 120 %}</a></td>
        <td class="view-message text-right">{{ comment.submit_date|timetag }}</td>
      </tr>
    {% empty %}
      <tr>
          {% if search_error %}
          <td style="text-align: center;"><h1>{% trans "Search Error: " %} {{ search_error }}</h1></td>
          {% else %}
          <td style="text-align: center;"><h1>{% trans "No topics yet" %}</h1><p><a href="{% url "forums:search.posts" %}?q={{ query }}">Click here</a> to do a comment body search</p></td>
          {% endif %}
      </tr>
    {% endfor %}
    </tbody>
  </table>
{% endblock %}

forums/templates/forums/ckeditor.html
{% load i18n l10n %}

<script>
document.addEventListener("DOMContentLoaded", function(event) {
    if(!$) {
        $ = django.jQuery;
    }
    CKEDITOR.config.language = '{{ language }}';
    CKEDITOR.replace('{{ ckeditor_selector }}',
    {
        mentions: [{
            // https://ckeditor.com/docs/ckeditor4/latest/guide/dev_autocomplete.html#templating
            feed: $(document).data('usernames'),
            minChars: 0,
            itemTemplate: '<li data-id="{id}" class="issue-{type}">{name}</li>',
            outputTemplate: '<a href="~{name}">{name}</a> ',
        }]
    });
});
</script>

forums/templates/forums/comment_table.html
{% load i18n static inkscape highlight search_tools %}

  <table class="table table-forum table-comment">
    <tbody>
    {% for comment in comment_list %}
      {% with comment.get_topic as topic %}
      <tr class="{% cycle 'odd' 'even' %}" data-changed="{{ topic.last_posted.isoformat }}" data-pk="topic-{{ topic.pk }}" data-author="{{ comment.user.username }}">
        {% if topic %}
          <th class="forum-small-cells avatar"><img src="{% if topic.forum.icon %}{{ topic.forum.icon.url }}{% endif %}"/></th>
          <th><a href="{{ topic.get_absolute_url }}#c{{ comment.pk }}">{{ topic }}</a></th>
        {% else %}
          <th><span class="glyphicon glyphicon-comment"></span></th>
          <th><a href="{{ comment.get_absolute_url }}">{% trans "Not a forum post" %}</a></th>
        {% endif %}
        <th class="view-message text-right text-muted"><span class="glyphicon glyphicon-time"></span> {{ comment.submit_date|timetag }}</th>
        <th class="forum-small-cells avatar" style="width: 1%;"><a href="{{ comment.user.get_absolute_url }}"><img src="{{ comment.user.photo_url }}" title="{{ comment.user }}"/></a></th>
      </tr>
    {% if query or show_comments %}
      <tr class="{% cycle 'odd' 'even' %}" data-changed="{{ comment.submit_date.isoformat }}" data-pk="comment-{{ topic.pk }}">
        <td class="view-message" colspan="2">
            {% if query %}
              {% highlight comment.comment with query max_length 200 %}
            {% else %}
              {% autoescape off %}
                {{ comment.comment|striptags|truncatechars:300 }}
              {% endautoescape %}
            {% endif %}
        </td>
        <td class="view-message text-center" colspan="2">
          {% if not comment.is_public and request.user.is_moderator %}
            <a href="{% url "forums:comment_public" comment.pk %}?next={{ request.path }}%3Fapprove={{ comment.pk }}%23c{{ comment.pk }}" class="btn btn-sm btn-success" title="{% trans "Approve (make public)" %}">
              <span class="glyphicon glyphicon-ok-sign"></span>
            </a>
            <a href="{% url "forums:comment_remove" comment.pk %}?next={{ request.path }}%3Frem={{ comment.pk }}" class="btn btn-sm btn-danger" title="{% trans "Remove" %}">
              <span class="glyphicon glyphicon-remove"></span>
            </a>
          {% endif %}
        </td>
      </tr>
      <tr class="sep"><td colspan="4"></td></tr>
    {% endif %}
      {% endwith %}
    {% empty %}
      <tr>
        <td class="icon forum-small-cells forum-no-results"><span class="glyphicon glyphicon-info-sign"></span></td>
        <td class="topic-item forum-no-results" colspan="6">
          {% if query %}
            {% blocktrans %}No comments found with search '{{ query }}'{% endblocktrans %}
          {% else %}
            {% trans "No comments" %}
          {% endif %}
        </td>
      </tr>
    {% endfor %}
    </tbody>
  </table>

forums/templates/forums/forumtopic_detail.html
{% extends "forums/base.html" %}
{% load i18n static forum_comments inkscape comments %}

{% block title %}{{ object.subject }} - {{ object.forum }}{% endblock %}

{% block "css" %}
<link href="{% static "slick/slick.css" %}" rel="stylesheet" type="text/css"/>
<link href="{% static "slick/slick-theme.css" %}" rel="stylesheet" type="text/css"/>
<link href="{% static "slick/lightbox.css" %}" rel="stylesheet" type="text/css"/>
<link href="{% static "forums/ckeditor/plugins/codesnippet/lib/highlight/styles/github.css" %}" rel="stylesheet" type="text/css"/>
{{ block.super }}
{% endblock %}

{% block "js" %}{{ block.super }}
<script type="text/javascript" src="{% static "slick/slick.min.js" %}"></script>
<script type="text/javascript" src="{% static "slick/lightbox.min.js" %}"></script>
<script type="text/javascript" src="{% static "forums/ckeditor/plugins/codesnippet/lib/highlight/highlight.pack.js" %}"></script>
<script>hljs.initHighlightingOnLoad();</script>
{% endblock %}

{% block "wrapper" %}
<div class="container-flex forums-app forums-topic-detail" {% if object.forum.emotes %}data-emotes="{{ object.forum.emotes }}"{% endif %}>
{% endblock "wrapper" %}

{% block "forumheader" %}
  <div class="forum-sub-header">
    {% include "forums/forumtopic_subheader.html" %}
  </div>
{% endblock %}

{% block "aside" %}{% endblock %}

{% block "tools" %}
  <div class="btn-group">
    <a data-original-title="Refresh" data-placement="top" href="" class="btn btn-sm"><span class="glyphicon glyphicon-refresh"><span></a>
  </div>
  {% if request.user.is_moderator %}
    <div class="btn-group">
      <a href="#" class="btn btn-sm btn-default disabled">{% trans "Moderator Tools:" %}</a>
      <a href="{% url "forums:topic_split" object.slug %}" class="btn btn-sm btn-default" title="{% trans "Split out Comments" %}"><span class="iw-flow-split"></span></a>
      <a href="{% url "forums:topic_merge" object.slug %}" class="btn btn-sm btn-default" title="{% trans "Merge into another Topic" %}"><span class="iw-flow-merge"></span></a>
      <a href="{% url "forums:topic_move" object.slug %}" class="btn btn-sm btn-primary" title="{% trans "Move Topic" %}"><span class="glyphicon glyphicon-move"></span></a>
      <a href="{% url "forums:topic_edit" object.slug %}" class="btn btn-sm btn-warning" title="{% trans "Edit Topic" %}"><span class="glyphicon glyphicon-edit"></span></a>
      <a href="{% url "forums:topic_delete" object.slug %}" class="btn btn-sm btn-danger" title="{% trans "Delete Topic" %}"><span class="glyphicon glyphicon-remove-sign"></span></a>
    </div>
  {% endif %}
  {% if request.user.is_authenticated %}
    {% with object|subscription:request.user as subscription %}
      <div class="btn-group">
        {% if not subscription %}
          <a class="btn btn-sm btn-danger" href="{% url "alert.subscribe" "forums.forum_topic_alert" object.pk %}?next={{ request.path }}&post=1">
            <span class="glyphicon glyphicon-heart"></span> {% trans "Subscribe" %}
          </a>
        {% else %}
          <a class="btn btn-sm btn-default" href="{% url "alert.unsubscribe" "forums.forum_topic_alert" object.pk %}?next={{ request.path }}&post=1">
            <span class="glyphicon glyphicon-heart-empty"></span> {% trans "Unsubscribe" %}
          </a>
        {% endif %}
        <a href="{% url "alert.settings" "forums.forum_topic_alert" %}?next={{ request.path }}" class="btn btn-sm btn-default" title="{% trans "Subscription Settings" %}"><span class="glyphicon glyphicon-wrench"></span></a>
      </div>
    {% endwith %}
  {% endif %}

  {% if object.locked %}
    <div class="btn-group">
      <a href="#" class="btn btn-sm btn-danger"><span class="glyphicon glyphicon-lock"></span> Topic Locked</a>
    </div>
  {% endif %}
{% endblock %}

{% block "content" %}
  {% if object.object_pk %}
    <div class="forum-comment-first changes" data-pk="topic-{{ object.pk }}">
      {% with object.object_template as template %}
        {% with object.object as object %}
          {% include template %}
        {% endwith %}
      {% endwith %}
    </div>
  {% endif %}

  {% get_forum_comment_list for object.comment_subject as comment_list %}
  <div class="panel-body haveseen" data-changed="{{ object.last_posted.isoformat }}" data-count="{{ object.post_count }}" data-pk="topic-{{ object.pk }}" data-model="topic">
    {% if object.is_contest %}
      {% include "forums/comment_thread.html" with override=object.attachments.all %}
    {% else %}
      {% include "forums/comment_thread.html" %}
    {% endif %}
  </div>
  
  {% if object.removed %}
    <div class="panel-footer">
        <h5 class="text-danger"><span class="glyphicon glyphicon-warning-sign"></span> {% trans "Moderators have removed this thread!" %}</h5>
    </div>
  {% elif object.locked %}
    <div class="panel-footer">
        <h5 class="text-danger"><span class="glyphicon glyphicon-warning-sign"></span> {% trans "Moderators have closed this thread, you may not post further comments here." %}</h5>
    </div>
  {% else %}

    {% get_forum_comment_form for object.comment_subject as comment_form %}
    {{ comment_form.media }}

  <div class="panel-footer">
    <div class="input-group">
      {% if object.form.is_locked or object.is_locked %}
        <input id="btn-input" disabled="disabled" type="text" class="form-control input-sm" />
        <span class="input-group-btn">
          <a class="btn btn-default btn-sm disabled"><span class="glyphicon glyphicon-lock"></span> {% trans "Locked" %}</a>
        </span>
      {% elif request.user.is_authenticated %}
        {% if request.user.email %}
          <form action="{% url "forums:comment_create" object.forum.slug object.slug %}" method="POST" class="block">
            <div class="row">
              {% csrf_token %}
              {{ comment_form.comment }}
              {{ comment_form.honeypot }}
              {{ comment_form.content_type }}
              {{ comment_form.object_pk }}
              {{ comment_form.timestamp }}
              {{ comment_form.security_hash }}
            </div>
            <div class="row group-id_attachments">
              {{ comment_form.attachments.label_tag }}
              {{ comment_form.attachments }}
            </div>
            <div class="row group-id_galleries">
              {{ comment_form.galleries.label_tag }}
              {{ comment_form.galleries }}
            </div>
            <div class="row group-id_embedded">
              {{ comment_form.embedded.label_tag }}
              {{ comment_form.embedded }}
            </div>

            {% include "forums/attachment_draw.html" %}
            <div class="row forum-topic-actions">

     <span class="btn-group pull-left" title="{% trans "Add attachments to topic" %}">
      <a id="add_attachments" class="btn btn-default btn-sm" style="display: none;"> <span class="glyphicon glyphicon-paperclip"></span></a>
    </span>
    <span class="btn-group pull-right">
      {% if perms.forums.can_post_topic %}
        <button class="btn btn-primary btn-sm" type="submit"> {% trans "Submit Reply" %}</button>
      {% else %}
        <button class="btn btn-warning btn-sm" type="submit"> {% trans "Submit Reply" %}</button>
      {% endif %}
    </span>
    <span class="btn-group pull-left">
      <a href="/community/coc/" target="_blank" class="btn"><span class="glyphicon glyphicon-check"></span> {% blocktrans %}Please read the <strong>Code of Conduct</strong> before posting.{% endblocktrans %}</a>
    </span>

            </div>
          </form>
        {% else %}
          <input id="btn-input" disabled="disabled" type="text" class="form-control input-sm" placeholder="You must have an email address to post!" />
          <span class="input-group-btn">
            <a href="{% url 'edit_profile' %}?next={{ request.path }}" class="btn btn-default btn-sm"> {% trans "Edit Profile" %}</a>
          </span>
        {% endif %}
      {% else %}
        <input id="btn-input" disabled="disabled" type="text" class="form-control input-sm" placeholder="You must be logged in to post!" />
        <span class="input-group-btn">
          <a href="{% url 'auth_login' %}?next={{ request.path }}" class="btn btn-danger btn-sm"> {% trans "Login Now" %}</a>
        </span>
      {% endif %}
    </div>
  </div>
  
  {% endif %}
  <div class="forum-breadcrumbs">
      <a href="/" title="Back to Inkcsape website"><img src="{% static "images/inkscape-logo.svg" %}" alt="Inkscape"> Inkscape.org</a>
      <span class="glyphicon glyphicon-chevron-right"></span>
      <a href="{% url "forums:list" %}"><img src="{% static "forums/images/logo.svg" %}"> Inkscape Forum</a>
      <span class="glyphicon glyphicon-chevron-right"></span>
      {% include "forums/forumtopic_subheader.html" %}
  </div>
{% endblock %}

forums/templates/forums/forumtopic_header.html
{% load i18n static %}

forums/templates/forums/moderationlog_list.html
{% extends "forums/base.html" %}
{% load i18n static inkscape %}
{% block title %}{% trans "Moderation Log" %}{% endblock %}
{% block "wrapper" %}
<div class="container-flex forums-app forums-moderationlog-list">
{% endblock "wrapper" %}
{% block "tools" %}
  <div class="alert alert-danger">
    <span class="glyphicon glyphicon-briefcase"></span> {% trans "This moderation log lists the actions taken by moderatiors on this website. Please contact the moderation team or systems administrator if you are having a problem with the forum moderation." %}
  </div>
  {{ block.super }}
{% endblock %}

{% block "content" %}
  <table class="table table-forum" data-pk="forum-{{ forum.pk }}">
    <tbody>
    {% for log in object_list %}
      <tr class="{% cycle 'odd' 'even' %} {{ log.get_log_color }}">
        <td class="subscribed forum-small-cells"><span class="glyphicon glyphicon-{{ log.get_log_icon }}"></span></td>
        <td class="view-message">{{ log.get_log_name }}</td>
        <td class="view-message">{{ log.moderator|default:"Doctor's ModBot" }}</td>
        <td class="view-message forum-small-cells text-muted">
          {% if log.comment %}
          <span class="glyphicon glyphicon-comment"></span> <a href="{% url "forums:comment_raw" log.comment.pk %}">#{{ log.comment.pk }}</a>
          {% elif log.topic %}
            <span class="glyphicon glyphicon-list-alt"></span> <a href="{{ log.topic.get_absolute_url }}">{{ log.topic.subject }}</a>
          {% else %}
            {% if log.details.subject %}
              <span class="glyphicon glyphicon-list-alt"></span> {{ log.details.subject }}
            {% elif log.details.text %}
              <span class="glyphicon glyphicon-comment"></span> #{{ log.details.comment.id }}
            {% elif log.details.comment.id %}
            <span class="glyphicon glyphicon-remove-circle"></span> #{{ log.details.comment.id }}
            {% elif log.details.phrase %}
            <span class="glyphicon glyphicon-ban-circle"></span> "{{ log.details.phrase }}"
            {% endif %}
          {% endif %}
        </td>
        <td class="view-message forum-small-cells text-muted">
          {% if log.user %}
            {% if not log.user.is_active %}
              <span class="glyphicon glyphicon-lock"></span>
            {% elif log.user.is_admin %}
              <span class="glyphicon glyphicon-briefcase"></span>
            {% else %}
              <span class="glyphicon glyphicon-user"></span>
            {% endif %}
            <a href="{{ log.user.get_absolute_url }}">{{ log.user }}</a>
          {% endif %}
        </td>
        <td class="view-message text-right text-muted"><span class="glyphicon glyphicon-time"></span> {{ log.performed|timetag }}</td>
      </tr>
    {% empty %}
      <tr>
          <td style="text-align: center;"><h1>{% trans "Nothing logged" %}</h1></td>
      </tr>
    {% endfor %}
    </tbody>
  </table>
{% endblock %}

forums/templates/forums/testobject_comments.html
HEADER<<{{ object }}>>END

forums/templates/forums/userflag_mod_list.html
{% extends "forums/userflag_list.html" %}
{% load i18n static inkscape %}
{% block title %}{% trans "Moderator List" %}{% endblock %}

{% block "tools" %}{% with sel as "mod" %}{{ block.super }}{% endwith %}{% endblock %}

{% block "content" %}
<form method="GET" action="{% url "forums:mod_user" %}">
  <table class="table table-forum table-hover">
    <thead>
      <tr>
        <th scope="col"></th>
        <th scope="col">{% trans "Username" %}</th>
        <th scope="col">{% trans "Moderator Title" %}</th>
        <th scope="col" class="text-right">{% trans "Mod Actions" %}</th>
        <th scope="col" class="text-left">{% trans "Last Active" %}</th>
        <th scope="col">{% trans "Perm" %}</th>
        <th scope="col" class="text-right">{% trans "Remove" %}</th>
      </tr>
    </thead>
    <tbody>
    {% for flag in page_obj %}
    <tr class="{% cycle 'odd' 'even' %}">
        <td class="text-right">
          <img src="{{ flag.user.photo_url }}" style="max-width: 45px; max-height: 45px; margin: -6px;"/>
        </td>
        <td class="user-item">
          <a href="{{ flag.user.get_absolute_url }}">{{ flag.user.username }}</a>
        </td>
        <td class="text-left">{{ flag.title }}</td>
        <td class="text-right"><span class="label label-default counter" title="{% trans "Number of Actions" %}">{{ flag.user.forum_moderation_actions.count }}</span></td>
        <td class="text-left text-muted">
          {% if flag.user.forum_moderation_actions.count %}
            <span class="glyphicon glyphicon-time"></span> {{ flag.user.forum_moderation_actions.last.performed|timetag }}
          {% else %}
            {% trans "Never" %}
          {% endif %}
        </td>
        <td class="text-center">
          {% if not flag.user.is_moderator %}
          <span class="label label-danger" title="{% trans "Missing permissions!" %}"><span class="glyphicon glyphicon-remove"></span></span>
          {% elif not flag.user.has_moderator %}
            <span class="label label-default" title="{% trans "Site Admin" %}"><span class="glyphicon glyphicon-briefcase"></span></span>
          {% else %}
            <span class="label label-success"><span class="glyphicon glyphicon-ok"></span></span>
          {% endif %}
        </td>
        <td class="text-right"><a href="{% url "forums:mod_user" %}?user={{ flag.user.username }}&next={{ request.path }}" class="btn btn-danger"><span class="iw-crown-minus"></span></td>
      </tr>
    {% empty %}
      <tr>
        <td class="icon forum-small-cells"><span class="glyphicon glyphicon-info-sign"></span></td>
        <td class="user-item">{% trans "No moderators" %}</td>
      </tr>
    {% endfor %}
    </tbody>
    <tbody>
      <tr class="active text-primary"><td colspan="7">
        <span class="glyphicon glyphicon-info-sign"></span> {% trans "Moderators are people who have a special responsibility to help the forum stay on track, clean and respectful to the rules. Adding users will also add the moderator's flag as well as enabeling the moderator's tools for that user." %}
      </td></tr>
      <tr class="active">
        <td>
            <span class="emoji">⚖</span>
        </th>
        <td><input type="text" placeholder="username" name="user"></th>
        <td><input type="text" placeholder="title" name="title" maxlength="127"></th>
        <td></th>
        <td></th>
        <td></th>
        <td class="text-right"><button type="submit" class="btn btn-success"><span class="iw-crown-plus"></span></button></th>
      </tr>
    </tbody>
  </table>
  <input type="hidden" name="next" value="{{ request.path }}"/>
  <input type="hidden" name="update" value="1"/>
</form>
{% endblock %}